/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.move.GEnterDynamicScene
 *  fire.pb.GsClient
 *  fire.pb.PropRole
 *  fire.pb.map.DuplicateHelper
 *  fire.pb.map.Transfer
 *  fire.pb.mission.SLandTask
 *  fire.pb.mission.SLandTaskConfig
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.DateValidate
 *  mkdb.Lockey
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.InstanceInfoCol
 *  xbean.InstanceTaskInfo
 *  xbean.Pod
 *  xtable.Instanceaskinfos
 *  xtable.Locks
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance;

import fire.msp.move.GEnterDynamicScene;
import fire.pb.GsClient;
import fire.pb.PropRole;
import fire.pb.map.DuplicateHelper;
import fire.pb.map.Transfer;
import fire.pb.mission.SLandTask;
import fire.pb.mission.SLandTaskConfig;
import fire.pb.mission.instance.InstanceManager;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.DateValidate;
import java.util.ArrayList;
import java.util.List;
import mkdb.Lockey;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.InstanceInfoCol;
import xbean.InstanceTaskInfo;
import xbean.Pod;
import xtable.Instanceaskinfos;
import xtable.Locks;
import xtable.Roleinstancetask;

public class PEnterInstanceMap
extends Procedure {
    private final long teamId;
    private final int instanceZoneId;

    public PEnterInstanceMap(long teamid, int instanceZoneId) {
        this.teamId = teamid;
        this.instanceZoneId = instanceZoneId;
    }

    protected boolean process() throws Exception {
        SLandTask taskCofig = InstanceManager.getInstance().getInstanceTask(this.instanceZoneId);
        if (taskCofig == null) {
            InstanceManager.logger.error((Object)("副本数据为空" + this.instanceZoneId));
            return false;
        }
        Team team = TeamManager.selectTeamByTeamID((long)this.teamId);
        if (team == null) {
            return false;
        }
        long roleid = team.getTeamLeaderId();
        ArrayList<Long> roleids = new ArrayList<Long>();
        roleids.addAll(team.getAllMemberIds());
        this.lock(Locks.ROLELOCK, roleids);
        Lockeys.lock((Lockey[])Lockeys.get((TTable)Locks.ROLEINSTANCETASK, roleids));
        if (!this.checkTask(team, taskCofig, roleids)) {
            InstanceManager.logger.error((Object)("队伍中有等级不足的情况," + this.instanceZoneId));
            return false;
        }
        InstanceInfoCol teamLeadreInfoCol = Roleinstancetask.select((Long)roleid);
        if (teamLeadreInfoCol == null) {
            return false;
        }
        int instanceZoneId = teamLeadreInfoCol.getLastinstanceid();
        InstanceTaskInfo teamLeadreTaskInfo = (InstanceTaskInfo)teamLeadreInfoCol.getInstinfo().get(instanceZoneId);
        if (teamLeadreTaskInfo == null) {
            return false;
        }
        teamLeadreInfoCol.setLastinstanceid(instanceZoneId);
        long currentTime = System.currentTimeMillis();
        int defaultTimes = InstanceManager.getInstance().getDayMaxTimes(roleid);
        teamLeadreInfoCol.setAccepttime(currentTime);
        teamLeadreTaskInfo.setAccepttime(currentTime);
        teamLeadreTaskInfo.setTotalexp(0);
        long instanceOnlyId = teamLeadreTaskInfo.getInstanceonlyid();
        SLandTaskConfig config = InstanceManager.getInstance().getTaskConfig(taskCofig.instancezoneid, 1, 0);
        if (config == null) {
            InstanceManager.logger.error((Object)("没有找到任务 taskType =" + instanceZoneId + " 1, 0"));
            return false;
        }
        for (long rid : roleids) {
            InstanceTaskInfo instanceInfo;
            InstanceInfoCol taskInfo = Roleinstancetask.get((Long)rid);
            if (taskInfo == null) {
                taskInfo = Pod.newInstanceInfoCol();
                Roleinstancetask.insert((Long)rid, (InstanceInfoCol)taskInfo);
            }
            if (!DateValidate.inTheSameDay((long)taskInfo.getAccepttime(), (long)currentTime)) {
                taskInfo.setCounts(0);
                taskInfo.setAccepttime(currentTime);
            }
            if ((instanceInfo = (InstanceTaskInfo)taskInfo.getInstinfo().get(instanceZoneId)) == null) {
                instanceInfo = Pod.newInstanceTaskInfo();
                taskInfo.getInstinfo().put(instanceZoneId, instanceInfo);
            }
            taskInfo.setLastinstanceid(instanceZoneId);
            if (!DateValidate.inTheSameDay((long)instanceInfo.getAccepttime(), (long)teamLeadreTaskInfo.getAccepttime())) {
                instanceInfo.setCounts(0);
                taskInfo.setCounts(0);
                instanceInfo.setDefaulttimes(defaultTimes);
                instanceInfo.setCurrentstep(1);
                instanceInfo.setCurrenttaskid(0);
                instanceInfo.setState(0);
                instanceInfo.getStepawardtimes().clear();
            }
            instanceInfo.setAccepttime(teamLeadreTaskInfo.getAccepttime());
            instanceInfo.setInstanceonlyid(instanceOnlyId);
            instanceInfo.setCurrentstep(teamLeadreTaskInfo.getCurrentstep());
            instanceInfo.setCurrenttaskid(config.getTaskid());
            instanceInfo.setInstanceflag(4);
        }
        List<Integer> mapList = InstanceManager.getInstance().getInstanceMapId(instanceZoneId);
        if (mapList == null) {
            return false;
        }
        for (Integer mapId : mapList) {
            DuplicateHelper.createDynamicMap((int)mapId, (long)instanceOnlyId, (String)"", (boolean)true, (int)-1, (int)0, null);
        }
        int xpos = taskCofig.getXzuobiao();
        int ypos = taskCofig.getYzuobiao();
        if (!Transfer.canChangeMap((long)roleid, (int)516022, (int)0)) {
            return false;
        }
        GsClient.pSendWhileCommit((Protocol)new GEnterDynamicScene(roleid, config.getMapid(), teamLeadreTaskInfo.getInstanceonlyid(), "", xpos, ypos, 1, 0x6DDD00, 0, 516026, null));
        Instanceaskinfos.remove((Long)this.teamId);
        TeamManager.getInstance().delTeamMatch(roleid);
        return true;
    }

    private boolean checkTask(Team team, SLandTask taskCofig, List<Long> allRoleIDs) {
        ArrayList<String> levelException = new ArrayList<String>();
        for (Long mem : allRoleIDs) {
            PropRole pRole = new PropRole(mem.longValue(), true);
            if (pRole.getLevel() >= taskCofig.getMinlevel()) continue;
            levelException.add(pRole.getName());
        }
        if (!levelException.isEmpty()) {
            StringBuffer strParam = new StringBuffer();
            int nIndex = 0;
            for (String name : levelException) {
                if (nIndex != levelException.size() - 1) {
                    strParam.append(name).append(",");
                    continue;
                }
                strParam.append(name);
            }
            ArrayList<String> paras = new ArrayList<String>();
            paras.add(strParam.toString());
            paras.add(String.valueOf(taskCofig.getMinlevel()));
            MessageMgr.psendMsgNotifyWhileRollback((long)team.getTeamLeaderId(), (int)160102, paras);
            return false;
        }
        if (allRoleIDs.size() < taskCofig.getTeamnum()) {
            ArrayList<String> paras = new ArrayList<String>();
            paras.add(String.valueOf(taskCofig.getTeamnum()));
            MessageMgr.psendMsgNotifyWhileRollback((long)team.getTeamLeaderId(), (int)160103, paras);
            return false;
        }
        return true;
    }
}

